<?php
include_once 'config.inc.php';

/****************************************************************************/
/************************** OBJECT FUNCTIONS ********************************/
/****************************************************************************/

function get_super_users () {
	$opers = "";
	$buf = read_file ($Config['cgi']);
	$lines = explode("\n", $buf);
	foreach($lines as $line) {
		$line = trim($line);
		if($line[0] == '#') continue;
		if(strstr($line, 'authorized_for_system_commands')) {
			$part = split(" *= *", $line, 2);
			$users = split(" *, *", $part[1]);
			foreach($users as $u) if($u === "*") return(true);
			else $opers[] = $u;
		}
	}
}

/* These are all layer 2 functions. They get called with the index-key
 * name for the $F-array, but pass the value to the file-functions. */

/* returns an indexed array of associative arrays where
 * tokens are the index-key for the value. Very nifty. */
function get_objects ($obj_type) {
	global $F;
	$inobj = false;
	if (!($buf = read_file ($F[$obj_type]))) return "No such file";

	$lines = explode ("\n", $buf);

	$objs = 0;
	foreach ($lines as $line) {
		if(strlen($line)){
		if ($line[0] == '{') { $inobj = true; continue; }
		if ($line[0] == '}') { $objs++; $inobj = false; continue; }
		if ($inobj === false) continue;

		$str = split ("\t", $line, 2);
		$ret_array[$objs][$str[0]] = $str[1];
		}
	}

	return ($ret_array);
}

/* takes an indexed array of associative arrays as input and writes them
 * to the file $F[$indexkey] in a format of token(=indexkey)\tvalue...
 * This is the function every script that modifies services and such MUST
 * use to glue their objects back together, or other functions will fail. */
function glue_objects2($objs, $obj_type) {
	global $F;

	/* keep working even if code is half-done */
	if (!(isset ($F[$obj_type]))) {
		echo "No value set in F for obj_type '$obj_type'<br>\n";
		return (false);
	}

	$buf = '';

	/* empty configuration files are ok, but generates error, since
	 * the $objs array doesn't get populated. Dealt with here */
	if (!is_array ($objs) || !count($objs)) {
		write_file ($F[$obj_type], $buf);
		return (true);
	}

	foreach ($objs as $obj_k => $obj) {
		if (!(is_array ($obj))) continue;
		$buf .= "{\n";
		foreach ($obj as $k => $v) {
			if ($v === false) continue;
			$buf .= $k . "\t" . $v . "\n";
		}
		$buf .= "}\n";
	}
	write_file ($F[$obj_type], $buf);

	return (true);
}

/* returns an indexed array of values for the token $token from file $fname */
function get_token_values ($token, $obj_type) {
	$objs = get_objects ($obj_type);
	if(!count($objs)) return(false);

	foreach ($objs as $obj) {
		if (!isset ($obj[$token])) continue;
		$ret_list[] = $obj[$token];
	}

	if(!count($ret_list)) return(false);
	natsort ($ret_list);
	return ($ret_list);
}

?>
