<?php
/*
 * These are layer 1 functions. They do exactly as they're told, without any
 * kind of conversion or anything. They don't need any include files at all,
 * and are the *LEAST* likely to contain bugs if anything goes amiss...
 */

/****************************************************************************/
/*************************** SYSTEM FUNCTIONS *******************************/
/*********************** (the dangerous ones ...) ***************************/
/****************************************************************************/

/* executes a command through popen and returns its output and return value */
function exec_cmd ($cmd) {
	$ret = array ('value' => false, 'buf' => "");
	$pd = "";
	$ph = popen ($cmd, "r") or die ($php_errormsg);
	while (true) {
		$pd = fread ($ph, 2048);
		if (strlen ($pd) == 0) break;
		$ret['buf'] .= $pd;
	}
	$ret['value'] = pclose ($ph);
	return $ret;
}

/****************************************************************************/
/**************************** FILE FUNCTIONS ********************************/
/****************************************************************************/

/* makes a blahblah. ;) */
function file_error ($mode, $name = 'some file') {
	echo html_font(3) . "<b>\n";
	if(!strlen($name)) {
		echo "file_error() called without filename<br>\n";
		echo "mode is $mode<br>\n";
		echo "This is a bug.<br>\n";
		echo "</font></b>\n";
		html_end();
	}
	printf ("Encountered problems while handling file %s\n", $name);
	if ($mode == 'noexist') {
		printf ("The file doesn't appear to exist.");
	}
	else if ($mode == 'lock') {
		printf ("Unable to obtain lock on file.");
	}
	else printf ("Unable to open file for %s.",
				 ($mode == 'write') ? "writing" : "reading");

	die ("Failed to access file.\n");
}

/* sharelocks a file and returns the contents */
function read_file ($name) {
	$cnt = 3;
	if (!(is_file ($name))) file_error ('noexist', $name);
	if (!($fh = fopen ($name, 'r'))) file_error ('read', $name);
	while ($cnt > 0) {
		$cnt--;
		$locked = flock($fh, LOCK_SH | LOCK_NB);
		if (!$locked) sleep (1);
	}
	if (!$cnt && !$locked) return false;

	$buf = fread ($fh, filesize ($name));
	flock ($fh, LOCK_UN);
	fclose ($fh);

	return $buf;
}

// opens a file, gets an exclusive lock, closes it and returns true on success
function write_file ($name, $buf) {
	$cnt = 3;
	if (!($fh = fopen ($name, 'w'))) file_error ('write', $name);
	while ($cnt > 0) {
		$cnt--;
// 		$locked = flock ($fh, LOCK_EX | NB);
		$locked = flock ($fh, LOCK_EX | LOCK_NB);
		if (!$locked) sleep (1);
	}
	if (!$locked) file_error ('lock', $name);

	if(!(fwrite ($fh, $buf))) file_error('write', $name);
	fflush ($fh);
	flock ($fh, LOCK_UN);
	fclose ($fh);

	return true;
}

// appends $buf to file $name with proper locking
function append_file ($name, $buf) {
	$cnt = 3;
	if (!($fh = fopen ($name, 'a'))) file_error ('append', $name);
	while ($cnt > 0) {
		$cnt--;
		$locked = flock ($fh, LOCK_EX | NB);
		if (!$locked) sleep (1);
	}
	if (!$locked) file_error ('lock', $name);
	fwrite ($fh, $buf);
	fflush ($fh);
	flock ($fh, LOCK_UN);
	fclose ($fh);

	return true;
}

?>
