// Restore has to work in both IE and FF...
var canSee = navigator.appName.indexOf("Microsoft") > -1 ? 'block' : 'table-row';
var path = '';
var report_type_id =false;
var current_filename;
$(document).ready(function(){
	var options = {
		target:			'#response',		// target element(s) to be updated with server response
		beforeSubmit:	validate_form,	// pre-submit callback
		success:		showResponse,	// post-submit callback
		clearForm:		true
	};

	$('#autoreports_schedule').submit(function() {
		$(this).ajaxSubmit(options);
		return false;
	});
	$("#rep_type").change( function() {
		$('#err_msg').text('');
		var value = $('#rep_type').fieldValue();
		if (value=='') {
			hide_rows();
			return false;
		}
		// call ajax function to get path for selected ID (value)
		// Ends up inside show_report() to display found reports
		get_report_data(value);
	});

	// edit (saved_reports)
	$("#report_type").change( function() {
		var value = $('#report_type').fieldValue();
		if (value[0]=='') {
			hide_rows();
			$('#saved_reports_table').hide();
			return false;
		}

		// call ajax function to get path for selected type (value)
		saved_items = '';
		show_progress('progress', 'Fetching data...');
		report_type_id = value[0];
		get_report_data(report_type_id);
		fetch_reports(report_type_id);
		$('#saved_reports_table').show();
	});

	$('#saved_reports_holder').change(function(){
		create_filename();
	});

	$('#period').change(function(){
		create_filename();
	});

	$(".periods").editable("save_item.php", {
		data : $('#tmp').text(),
		id   : 'elementid',
		name : 'newvalue',
		event : 'dblclick',
		type : 'select',
		submit : 'OK',
		cancel : 'cancel'
	});
	$(".iseditable").editable("save_item.php", {
		id   : 'elementid',
		name : 'newvalue',
		type : 'text',
		event : 'dblclick',
		width : 'auto',
		height : '14px',
		submit : 'OK',
		cancel : 'cancel',
		placeholder:'Double-click to edit'
	});
	$(".iseditable_txtarea").editable("save_item.php", {
		indicator : "<img src='media/indicator.gif'>",
		id   : 'elementid',
		name : 'newvalue',
		type : 'textarea',
		select:	true,
		event : 'dblclick',
		rows: '3',
		submit : 'OK',
		cancel : 'cancel',
		cssclass: "txtarea",
		placeholder:'Double-click to edit'
	});
	$(".delete_report").click( function() {
		delete_schedule(this.id);
	});
	$(".send_report_now").click( function() {
		send_report_now(this.id);
	});
	$(".report_name").editable("save_item.php", {
		data : function (){
			return fetch_report_data(this.id);
		},
		id   : 'elementid',
		name : 'newvalue',
		event : 'dblclick',
		type : 'select',
		submit : 'OK',
		cancel : 'cancel'
	});

	$('#filterbox').keyup(function(){
		filter_table(this, 'all_reports', 1);
	})
	.focus(function(){
		if(this.value=='Type text to filter') {
			this.value=''
		}
	});
	$("#all_reports").tablesorter({
		sortList: [[0,0], [1,0]],
		sortClassAsc: 'headerSortUp',
		sortClassDesc: 'headerSortDown',
		highlightClass: 'highlight',
		headerClass: 'headerSortUp'
	});
	$("#all_reports tr").hover(function() {
		$(this).addClass("highlight");
	}, function() {
		$(this).removeClass("highlight");
	});
	var description_visible = false;
	$('#description_link').click(function(){
		if (description_visible) {
			$('#description_area_help').hide();
			description_visible = false;
		} else {
			$('#description_area_help').show();
			description_visible = true;
		}
	});
	$('#howtoedit_link').click(function(){
		if (description_visible) {
			$('#howtoedit').hide();
			description_visible = false;
		} else {
			$('#howtoedit').show();
			description_visible = true;
		}
	});
	$('#desc_close').click(function(){
		if (description_visible) {
			$('#description_area_help').hide();
			description_visible = false;
		} else {
			$('#description_area_help').show();
			description_visible = true;
		}
	});
	$('#saved_desc_close').click(function(){
		if (description_visible) {
			$('#howtoedit').hide();
			description_visible = false;
		} else {
			$('#howtoedit').show();
			description_visible = true;
		}
	});
});

function filter_table (phrase, _id){
	var words = phrase.value.toLowerCase().split(" ");
	var table = document.getElementById(_id);
	var ele;

	for (var r = 1; r < table.rows.length; r++){
		ele = table.rows[r].innerHTML.replace(/<[^>]+>/g,"");
		var displayStyle = 'none';
		for (var i = 0; i < words.length; i++) {
			if (ele.toLowerCase().indexOf(words[i])>=0)
				displayStyle = '';
			else {
				displayStyle = 'none';
				break;
			}
		}
		table.rows[r].style.display = displayStyle;
	}
}

function fetch_report_data(id)
{
	parts = id.split('-');
	type_id = get_type_id(parts[0]);
	var data = eval('(' + $('#saved_reports').text() + ')');
	var json_items = "{";
	var a = 0;
	var obj = data[type_id];
	for (i in obj) {
		json_items += '"' + i + '":"' + obj[i] + '"';
		json_items += ',';
	}
	json_items = json_items.slice(0, -1);
	json_items += "}";
	return json_items;
}

function get_type_id(str)
{
	parts = str.split('.');
	return parts[0];
}

/**
*	Fetches scheduled reports from database
*/
function fetch_reports(val) {
	xajax_fetch_reports(val);
}

function hide_rows()
{
	$('#saved_reports_row').hide();
	$('#periods_holder_row').hide();
	$('#recipients_holder').hide();
	$('#filename_holder').hide();
	$('#description_area').hide();
	$('#action_button').hide();
}

var saved_items = '';
var json_items = '';
function show_reports(data)
{
	if (!saved_reports.length) {
		$('#saved_reports_row').css('display', canSee);
		$('#periods_holder_row').css('display', canSee);
		$('#recipients_holder').css('display', canSee);
		$('#filename_holder').css('display', canSee);
		$('#description_area').css('display', canSee);
		$('#action_button').css('display', canSee);
	}
	if (data!='') {
		saved_items = data; // cache for later use
		obj = eval(data);
		json_items = '{';
		var select = '<select id="saved_report_id" name="saved_report_id">';
		var a = 0;
		for (i in obj) {
			 if (typeof(obj[i].name) != 'undefined' && typeof(obj[i].id) != 'undefined') {
				a++;
				select +=  '<option value="' + obj[i].id +'">'+ obj[i].name + '</option>';
				json_items += '"' + obj[i].id + '":"' + obj[i].name + '"';
				if (a != obj.length) json_items += ',';
			}
		}
		json_items += '}';
		select += '</select>';
		$('#saved_reports_holder').html(select);
		create_filename();
		$('#saved_items').text(json_items);
	} else {
		$('#saved_reports_holder').text('Found no reports');
	}
}

function create_filename()
{
	var new_filename = $('#saved_reports_holder option:selected').text();
	new_filename += '_' + $('#period option:selected').text() + '.pdf';
	if ($('input[@name=filename]').val() != '' && $('input[@name=filename]').val() != current_filename) {
		if (!confirm('Would you like to change the filename based on your selections?')) {
			return false;
		}
	}
	$('input[@name=filename]').val(new_filename);
	current_filename = new_filename;
	return true;
}

function log(msg)
{
	if (window.console && window.console.log) {
		console.log(msg);
	} else {
		alert(msg);
	}
}

function showResponse(responseText, statusText)
{
	$('#response').text(responseText);
	hide_rows();
	// hide message after 3 seconds
	setTimeout ("hide_message();", 3000);
	return true;
}

function hide_message(the_id)
{
	the_id = (the_id==null) ? '#response' : the_id;
	$(the_id).text('');
}

/**
*	Fetch report path from db through xajax call
*	Eventually passes focus to show_reports()
*/
function get_report_data(id)
{
	xajax_fetch_module_reports(id);
}

/**
*	Hide progress indicator
*/
function hide_progress(delay)
{
	if(typeof(delay) != 'undefined')
	{
		delay = parseInt(delay);
		if(delay > 0)
			setTimeout('hide_progress();', delay);
	}
	else
	{
		$('#progress').hide();
	}
}

/**
*	Make sure all values are properly entered
*/
function validate_form(formData, jqForm, options) {
    var report_type = $('#rep_type').fieldValue();
    var period = $('#period').fieldValue();
	var err_str = "";
	var errors = 0;

	if (!report_type[0]) {
		err_str += ' -No report type selected\n';
		errors++;
	} else {
	    var saved_report_id = $('#saved_report_id').fieldValue();
		if (!saved_report_id[0]) {
			err_str += ' -No saved report selected\n';
			errors++;
		}
		var recipients = $('#recipients').fieldValue();
		if (!recipients[0]) {
			err_str += ' -Missing recipient(s)\n';
			errors++;
		}
		var filename = $('#filename').fieldValue();
		if (!filename[0]) {
			err_str += ' -Missing filename\n';
			errors++;
		}
		if (filename[0].indexOf('/')!=-1) {
			err_str += ' -Filename should not be a path';
			errors++;
		}
		if (!period[0]) {
			err_str += ' -No time period selected\n';
			errors++;
		}
	}
	if (errors) {
		alert('Found the following error(s):\n' + err_str + '\nPlease correct this and try again');
		return false;
	}

    return true;
}

var saved_reports = new Array();
function show_saved_reports(data) {
	saved_reports = data;
	show_progress('progress', 'Please wait...');
	availObj = eval(data);
	var title_str = 'Doubleclick to edit value';
	output = '<table id="saved_reports_table" class="saved_reports">';
	output += '<thead>\n';
	output += '<th>Report name</th>\n';
	output += '<th class="invisible"></th>\n';
	output += '<th class="invisible"></th>\n';
	output += '<th>Interval</th>\n';
	output += '<th>Recipients</th>\n';
	output += '<th colspan="2">Filename</th>\n';
	output += '</thead>';
	output += '<tbody>';

	for (i=0;i<availObj.length;i++) {
		//saved_reports[i] = availObj[i]['report_id'];
		output += '<tr title="' + title_str + '" class="odd" id="report-' + availObj[i]['id'] + '">';
		output += '<td title="' + title_str + '" class="rep_name" id="report_id-' + availObj[i]['id'] + '"></td>';
		output += '<td class="invisible" title="' + title_str + '" id="item_id-' + availObj[i]['id'] + '">' + availObj[i]['id'] + '</td>';
		output += '<td class="invisible" title="' + title_str + '" id="report_identifier-' + availObj[i]['id'] + '">' + availObj[i]['report_id'] + '</td>';
		output += '<td title="' + title_str + '" class="period_select" id="period_id-' + availObj[i]['id'] + '">' + availObj[i]['periodname'] + '</td>';
		output += '<td title="' + title_str + '" class="editable" id="recipients-' + availObj[i]['id'] + '">' + availObj[i]['recipients'].replace(/,/g, ', ') + '</td>';
		output += '<td title="' + title_str + '" class="editable" id="filename-' + availObj[i]['id'] + '">' + availObj[i]['filename'] + '</td>';
		output += '<td title="Click to delete this schedule" class="del_report" id="' + availObj[i]['id'] + '"><img src="/media/delete.gif"></td>';
		output += '</tr>';
	}
	output += '</tbody>';
	output += '</table>';
	// give the client time to populate table
	// before trying to manipulate
	$('#output').html(output);
	setTimeout ("hide_rows();", 300);
	setTimeout ("print_report_names();", 200);
	setTimeout ("check_for_names();", 300);
}

function check_for_names()
{
	if ($(".rep_name:contains('click to edit')") || $('.rep_name').text()=='') {
		show_progress('progress', 'Checking...');
		//log($('.rep_name').text());
		setTimeout ("print_report_names(true);", 100);
	}
}

// fetch report names from saved report
// in module
function print_report_names(re_run)
{
	if (saved_items=='') return false;
	re_run = (re_run==null) ? false : true;
	tmp = saved_items;
	//log(saved_items);
	obj = eval(saved_items);
	$('table#saved_reports_table tr').each(function(el) {
		for (i in obj) {
			if (obj[i].id == $(this).children().eq(2).text()) {
				$(this).children().eq(0).text(obj[i].name);
				$(this).children().eq(1).hide();
				$(this).children().eq(2).hide();
				break;
			}
		}
	});
	$(".editable").editable("save_item.php", {
		id   : 'elementid',
		name : 'newvalue',
		type : 'text',
		event : 'dblclick',
		width : 'auto',
		height : '14px',
		submit : 'OK',
		cancel : 'cancel',
		placeholder:'Double-click to edit'
	});

	// make periodname dynamic editfield
	//"{'1':'Weekly','2':'Monthly'}"
	$(".period_select").editable("save_item.php", {
		data : $('#tmp').text(),
		id   : 'elementid',
		name : 'newvalue',
		event : 'dblclick',
		type : 'select',
		submit : 'OK',
		cancel : 'cancel'
	});
	$(".rep_name").editable("save_item.php", {
		data : $('#saved_items').text(),
		id   : 'elementid',
		name : 'newvalue',
		event : 'dblclick',
		type : 'select',
		submit : 'OK',
		cancel : 'cancel'
	});
	if (!re_run) { // only register del_report onclick event once
		$(".del_report").click( function() {
			delete_schedule(this.id);
		});
	}
	hide_progress();
}

function delete_schedule(id)
{
	if (confirm("Are you really sure that you wish to delete this scheduled report?\nThis action can't be undone.")) {
		xajax_delete_schedule(id);
	}
}

function send_status(status)
{
	if (status==1)
		$.jGrowl("Report has been sent", { header: "SUCCESS" });
	else
		$.jGrowl("Failed to send report", { header: "ERROR" });
	hide_progress();
}

function send_report_now(id)
{
	show_progress('progress', 'Sending report...');
	xajax_send_report_now(id);
}

function remove_deleted_row(id) {
	$('#report-' + id).hide();
	$('#err_msg').text();
	setTimeout ("hide_message('#err_msg');", 3000);
}
function get_saved_reports(id)
{
	xajax_get_saved_reports(id);
}

var data = '';
function report_data(in_data)
{
	data = in_data;
	$('#saved_items').text(in_data);
}

function fetch_field_value(type, id, elem_id)
{
	xajax_fetch_field_value(type, id, elem_id);
}
