<?php

require_once '/var/www/html/op5common/lib/mailmsg_class.php';
require_once('include/user_config.inc.php');

/**
 * @param $recipients array Email addresses of recipients
 * @param $attach_filename string Filename of attachment
 * @param $attach_name string Name of attachment
 *
 */
function send_report(&$recipients, $attach_filename, $attach_name)
{
	global $mail_sender_address;
	$attach_name = basename($attach_name);
	$subject = "Scheduled report: $attach_name";
	$from = "op5Monitor"; # same as in notifications
	$mail_sender_address = trim($mail_sender_address);
	if (!empty($mail_sender_address)) {
		$from_email = $mail_sender_address;
	} else {
		$hostname = exec('hostname --long');
		if (empty($hostname) && $hostname != '(none)') {
			// unable to get a valid hostname
			$from_email = $from . '@localhost';
		} else {
			$from_email = $from . '@'.$hostname;
		}
	}

	$mail_msg = new MailMsg($subject, $from_email);

#	$mail_msg->vAddRecipient($from_email); # send confirmation email to sender

	foreach($recipients as $rec)
	{
		$mail_msg->vAddRecipient($rec);
	}

	$text_body = <<<EOT
Scheduled report sent from op5 Monitor
EOT;
	$mail_msg->bAddPlainPart($text_body);
	$attach_name = substr($attach_name, -4, 4) == '.pdf' ? $attach_name : $attach_name.'.pdf';
	$mail_msg->bAddAttachment($attach_filename, $attach_name);

	$mail_msg->bSendMail();
	unset($mail_msg);
}

?>
