#!/bin/sh
if [ -d /opt/monitor/op5/auto-reports ]; then
  prefix=/opt/monitor/op5/auto-reports
else
  prefix=/opt/op5/monitor/op5/auto-reports
fi


# Create table if not exist
mysql monitor_gui < $prefix/auto_reports.sql
# Lazy... Alter table to support 255 chars in contact field.
mysql monitor_gui -e "ALTER TABLE auto_reports MODIFY contacts varchar(255)"
mysql monitor_gui -Be 'DESCRIBE auto_reports' | grep ^scheduleddowntimeasuptime &> /dev/null || \
                      mysql monitor_gui < $prefix/upgrade_v1.4.4-to-1.6.0.sql
mysql monitor_gui -e "ALTER TABLE auto_reports MODIFY scheduleddowntimeasuptime  varchar(4) DEFAULT 'no'"
mysql monitor_gui -e "UPDATE auto_reports SET scheduleddowntimeasuptime='yes' WHERE scheduleddowntimeasuptime='1'"
mysql monitor_gui -e "UPDATE auto_reports SET scheduleddowntimeasuptime='no' WHERE scheduleddowntimeasuptime='0'"

if ! $(mysql monitor_gui -Be "SHOW TABLES" | grep "auto_reports_db_version" > /dev/null); then
    mysql monitor_gui < $prefix/autoreports.sql
	
	# convert old scheduled reports to v2.0 format:
	# 1  SELECT * FROM auto_reports
	# 2a INSERT INTO avail_config
	# 2b INSERT INTO avail_config_objects
	# 2c INSERT INTO auto_reports_scheduled
	/usr/bin/php -d safe_mode=0 $prefix/convert_to_2.0.php
	echo "Old scheduled reports has been imported and converted to new format!"
fi
								
# Check version
query='SELECT version FROM auto_reports_db_version'
ver=$(mysql monitor_gui -Be "$query" 2>/dev/null | sed -n \$p)
case "$ver" in
    2.0.0)
        # Add description field to auto_reports_scheduled
		mysql monitor_gui < $prefix/upgrade_2.0.1-to-2.0.2.sql
		query="UPDATE auto_reports_db_version SET version='2.1.1'"
		mysql monitor_gui -Be "$query"  > /dev/null
		;;
	2.0.2)
	    # Add support for Daily reports
		sql='SELECT * FROM auto_reports_periods';
		if ! $(mysql monitor_gui -Be "$sql" | grep "Daily" > /dev/null); then
			mysql monitor_gui < $prefix/upgrade_2.1.0-to-2.1.1.sql
			query="UPDATE auto_reports_db_version SET version='2.1.1'"
			mysql monitor_gui -Be "$query"  > /dev/null
		fi
		;;
esac

