<?php
require_once('include/template_class.php');
require_once('/opt/monitor/op5/gui/db_utils.inc.php');
require_once('include/auto-reports.inc.php');
require_once('include/config.inc.php');
require_once('/opt/monitor/op5/gui/gui_api.inc.php');
require_once('paths.inc.php');
require_once('/opt/monitor/op5/reports/gui/auth.php');
$mon_auth = new monitor_auth_class(get_array_var($_SERVER, 'REMOTE_USER'));
require_once($op5common_path."/lib/json_class.php");
require_once($op5common_path . '/lib/common.php');
$tpl = new Template('templates/index.tpl.php');
$tpl->assign('title', 'Schedule Reports');
$tpl->assign('op5common_path', $op5common_path);

/**
	-----------------------------
	List ALL scheduled reports:
	-----------------------------

	1.
	Fetch all scheduled reports
		1a.
		fetch_saved_reports() // NO type_id => ALL
		1b.
		fetch_saved_report_types();

	2.
	Fetch all saved reports from available modules
		2a.
		fetch_module_reports(false,false)
			// Both input params set to false => ALL types, NOT ajax
			// Returns $res for further processing
		2b.
		Fetch available report periods

		2c.
		Loop through result
			include script_reports_path for each result
			and assign returned data ($return) to array indexed by id

	3.
	Assign scheduled reports and saved reports to template
		Loop through arrays and generate table by PHP
		Create ondblclick event for editing records

*/
$menubox = new Template('templates/menubox.tpl.php');
$tpl->assign('menubox', $menubox);

$scheduled = new Template('templates/scheduled.tpl.php');

# 1a.
$saved_res = fetch_saved_reports();
$scheduled->assign('saved_res', $saved_res);

# 1b.
$types_res = fetch_saved_report_types();
$report_types = false;
while ($type_row = sql_fetch_array($types_res)) {
	$report_types[$type_row['report_type_id']] = $type_row['name'];
}
$scheduled->assign('report_types', $report_types);

# 2a.
$module_res = fetch_module_reports(false,false);
$saved_reports = false;
while ($info = sql_fetch_array($module_res)) {
	$path = $info['script_reports_path'];
	include($path);
	if (!empty($return)) {
		foreach ($return as $data) {
			$saved_reports[$info['id']][$data['id']] = $data['name'];
		}
	}
}
$scheduled->assign('saved_reports', $saved_reports);
$scheduled->assign('title_str', "Doubleclick to edit schedule");

# 2b.
$periods_res = get_available_report_periods();
while ($period_row = sql_fetch_array($periods_res)) {
	$periods[$period_row['id']] = $period_row['periodname'];
}
$scheduled->assign('periods', $periods);

$tpl->assign('content', $scheduled);
echo $tpl->fetch();
?>