<?php

chdir(dirname(__FILE__));
require_once '../gui/db_utils.inc.php';


set_time_limit(7200); # 2 hours
$start_time = time();


if($argc < 2)
{
	error_log(sprintf("usage: %s period", $argv[0]));
	exit;
}

$period = ucfirst($argv[1]);

gui_db_connect();

$q = "SELECT * FROM auto_reports_periods";
$res = sql_exec_query($q);

$period_id = false;
while($row = sql_fetch_array($res))
{
	if($row['periodname'] == $period)
	{
		$period_id = $row['id'];
		break;
	}
}

if(!$period_id)
{
	error_log("Invalid period: '$period', aborting job");
	exit;
}

$report_types = array();
$q = "SELECT * FROM auto_report_types";
$res = sql_exec_query($q);
while($row = sql_fetch_array($res))
{
	$report_types[$row['id']] = $row;
}


$q = "SELECT * FROM auto_reports_scheduled WHERE period_id = $period_id";
$rslt = sql_exec_query($q);

$reports = array();
while($sched_row = sql_fetch_array($rslt))
{
	if(empty($sched_row['recipients']))
	{
		error_log(sprintf("No recipients for scheduled report #%d, skipping", $sched_row['id']));
		continue;
	}
	if(!array_key_exists($sched_row['report_type_id'], $report_types))
	{
		error_log(sprintf("Unknown report type '%d', skipping", $sched_row['report_type_id']));
		continue;
	}

	$reports[] = $sched_row;
}

error_log(sprintf("Running %s scheduled reports, %d pending", $period, count($reports)));

foreach($reports as $i => $report)
{
	$report_id 		= $report['report_id'];
	$report_type_id = $report['report_type_id'];

	$recipients 	= str_replace(' ', '', $report['recipients']);

	if(empty($recipients))
	{
		error_log("Skipping report #$report_id which has no recipients!");
		continue;
	}

	$filename 		= $report['filename'];
	$runner_script = $report_types[$report_type_id]['script_reports_run'];

	$argc = 4;
	$argv = array($runner_script, $report_id, $recipients, $filename);

	error_log("Generating report #$i (id=".$report['id']." report_id=$report_id, report_type_id=$report_type_id)");

	include $runner_script;
}

$duration = time() - $start_time;
error_log(sprintf("Scheduled reports completed after %d seconds.", $duration));

?>
